#include "GCMotion.h"
#include "string.h"
#include <windows.h>
#include <math.h>
using namespace System;
using namespace System::Windows::Forms;

/*****************************************************************
* Function Name : 指令返回值
* Description   : 返回错误值 rtn
* Date			: 2022年8月3日
* Auther		: LWH
******************************************************************/
short gc_rtn_error(short rtn)
{
	if (rtn != RTN_CMD_SUCCESS) {
		MessageBox::Show(Convert::ToString(rtn));
		return rtn;		// 指令执行错误
	}
}

/*****************************************************************
* Function Name : 电子齿轮
* Description   : 略
* Date			: 2022年8月3日
* Auther		: LWH
******************************************************************/
short gc_example(void)
{
	short rtn;					// 指令返回值
	short devNum;				// 设备序号，从0开始
	short axisNum;				// 轴号，从0开始
	HAND devHandle;				// 设备句柄
	HAND axisHandle[2];			// 轴句柄
	HAND crdHandle;				// 坐标系句柄
	rtn = NMC_DevOpen(devNum, &devHandle);				//打开控制器
	gc_rtn_error(rtn);
	for (short i = 0; i < 2; i++) {
		rtn = NMC_MtOpen(devHandle, i, &axisHandle[i]);	//打开轴,并获得轴句柄
		gc_rtn_error(rtn);
		rtn = NMC_MtSetSvOn(axisHandle[i]);					//打开轴使能(根据实际情况使用)
		gc_rtn_error(rtn);
	}
	//设置轴2的运动模式为电子齿轮模式(轴2为主轴，轴1为从轴)
	rtn = NMC_MtSetPrfMode(axisHandle[1], MT_GEAR_PRF_MODE);
	gc_rtn_error(rtn);
	//设置Gear跟随方向
	rtn = NMC_MtGearSetDir(axisHandle[0], 0);
	gc_rtn_error(rtn);
	//设置主轴2规划器
	rtn = NMC_MtGearSetMaster(axisHandle[0], 1, 1);
	gc_rtn_error(rtn);
	//设置传动比5:4和离合区
	rtn = NMC_MtGearSetRatio(axisHandle[0], 5, 4, 2000);
	gc_rtn_error(rtn);
	//启动电子齿轮运动，当主轴运动时，从轴将按照设置的传动比和离合区运动,运动过程中调用NMC_MtGearSetRatio可更新传动比和离合区参数
	rtn = NMC_MtGearStartMtn(axisHandle[0], 0, 0);
	gc_rtn_error(rtn);
	return 0;
}
